#ifndef _MY_LAYER_OPTIMIZE_FUNCTIONS
#define _MY_LAYER_OPTIMIZE_FUNCTIONS

#include <stdio.h>
#include "myLightField.h"
#include "myLayerStack.h"
#include "myFocalStack.h"

class myLayerOptimize{

private:

	int mSetFlag;
	int mW;
	int mH;
	int mT;
	int mP;
	int mCH;

	void optimizeOneLayerUseLightField(myLayerStack *LS, myLightField *LF, int opt_lay, int LayerNum, int Approx);
	void UpdatePix_Accurate(myLayerStack *LS, myLightField *LF, myLightField *nowLF, int opt_lay, int LayerNum, int x, int y);
	void UpdatePix_Approx(myLayerStack *LS, myLightField *LF, myLightField *nowLF, int opt_lay, int LayerNum, int x, int y);


public:
	myLayerOptimize(void);
	~myLayerOptimize(void);

	void setParameter(int W, int H, int T, int P, int CH);
	void optimizeLayerStackWithLightField(myLayerStack *LS, myLightField *LF, int Approx, int ITER_MAX);

};

#endif
